SystemOrganization addCategory: #'Jet-Model'!

RGFactory subclass: #JETFactoryChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETFactoryChange methodsFor: 'classes' stamp: 'VeronicaUquillas 12/19/2011 11:38'!
addedChangeClass

	^JETAddedChange ! !

!JETFactoryChange methodsFor: 'object creation' stamp: 'VeronicaUquillas 5/17/2011 15:14'!
createAddedChange: aRGObject

	^self addedChangeClass new
		entity: aRGObject! !

!JETFactoryChange methodsFor: 'object creation' stamp: 'VeronicaUquillas 5/17/2011 15:14'!
createModifiedChange: aRGObject

	^self modifiedChangeClass new
		entity: aRGObject! !

!JETFactoryChange methodsFor: 'object creation' stamp: 'VeronicaUquillas 5/17/2011 15:25'!
createModifiedChangeFrom: obsolete to: substitute

	^self modifiedChangeClass new
		obsoleteEntity: obsolete;
		substituteEntity: substitute;
		yourself   ! !

!JETFactoryChange methodsFor: 'object creation' stamp: 'VeronicaUquillas 5/17/2011 15:13'!
createRemovedChange: entity

	^self removedChangeClass new
		entity: entity;
		yourself! !

!JETFactoryChange methodsFor: 'object creation' stamp: 'VeronicaUquillas 5/17/2011 15:30'!
createRenamedChange: entity to: oldName

	^self renamedChangeClass new
		entity: entity;
		oldName: oldName;  
		yourself! !

!JETFactoryChange methodsFor: 'classes' stamp: 'VeronicaUquillas 12/19/2011 11:41'!
modifiedChangeClass

	^JETModifiedChange! !

!JETFactoryChange methodsFor: 'classes' stamp: 'VeronicaUquillas 12/19/2011 11:41'!
removedChangeClass

	^JETRemovedChange! !

!JETFactoryChange methodsFor: 'classes' stamp: 'VeronicaUquillas 12/19/2011 11:41'!
renamedChangeClass

	^JETRenamedChange! !

RGObject subclass: #JETChange
	instanceVariableNames: 'entity delta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

JETChange subclass: #JETAddedChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETAddedChange classSide methodsFor: 'class initialization' stamp: 'VeronicaUquillas 7/13/2011 15:31'!
of: aRGHistory

	^ self new 
		entity: aRGHistory! !

!JETAddedChange methodsFor: 'comparing' stamp: 'VeronicaUquillas 11/28/2011 16:28'!
= aRGAddedChange

	^self class = aRGAddedChange class
		and:[ self entity = aRGAddedChange entity ]
! !

!JETAddedChange methodsFor: 'testing' stamp: 'VeronicaUquillas 12/8/2011 13:51'!
canHaveDependencies

	^ self entity canHaveDependencies ! !

!JETAddedChange methodsFor: 'comparing' stamp: 'VeronicaUquillas 11/28/2011 16:28'!
hash 

	^self class hash bitXor: self entity hash! !

!JETAddedChange methodsFor: 'testing' stamp: 'VeronicaUquillas 7/13/2011 15:36'!
isAddition

	^true! !

!JETAddedChange methodsFor: 'printing' stamp: 'VeronicaUquillas 7/18/2011 12:50'!
printOn: aStream 

	super printOn: aStream.
	aStream nextPutAll: ' <added>'! !

!JETChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/8/2011 19:55'!
allPredecessors
	| myPredecessors pred |
	
	myPredecessors := Set new.
	self delta allPredecessors do:[ :each| 
		pred := each mergedChanges detect:[ :c| c entity historyID = self entity historyID ] ifNone:[ nil ].
		pred notNil ifTrue: [ myPredecessors add: pred ]  ].
	^ myPredecessors asOrderedCollection ! !

!JETChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/8/2011 19:55'!
allSuccessors
	| mySuccessors succ |
	
	mySuccessors := Set new.
	self delta allSuccessors do:[ :each| 
		succ := each mergedChanges detect:[ :c| c entity historyID = self entity historyID ] ifNone:[ nil ].
		succ notNil ifTrue: [ mySuccessors add: succ ]  ].
	^ mySuccessors asOrderedCollection ! !

!JETChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/8/2011 16:08'!
delta

	^ delta! !

!JETChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/8/2011 16:08'!
delta: aRGSnapshotDelta 

	delta := aRGSnapshotDelta ! !

!JETChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/17/2011 15:33'!
entity

	^entity! !

!JETChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/17/2011 15:33'!
entity: aRGObject

	entity:= aRGObject ! !

!JETChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 10/10/2011 16:03'!
fullName

	^ entity fullName! !

!JETChange methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/8/2011 19:08'!
futureChanges 

	^ self allSuccessors! !

!JETChange methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/8/2011 19:08'!
globalChanges

	^ self withAllPredecessorsAndSuccessors! !

!JETChange methodsFor: 'testing' stamp: 'VeronicaUquillas 12/9/2011 00:53'!
hasChangedDefinitionSource

	^ false! !

!JETChange methodsFor: 'testing' stamp: 'VeronicaUquillas 12/9/2011 00:53'!
hasChangedSourceCode

	^ false! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 5/17/2011 12:57'!
isAccessChange

	^self entity isAccess! !

!JETChange methodsFor: 'testing kind of changes' stamp: 'VeronicaUquillas 7/13/2011 15:37'!
isAddition

	^false! !

!JETChange methodsFor: 'testing' stamp: 'VeronicaUquillas 11/25/2011 11:26'!
isChange

	^ true! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 11/10/2011 13:26'!
isClassChange

	^self entity isClass or:[ self entity isTrait ]! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 10/10/2011 15:20'!
isClassInstanceVariableChange

	^self entity isVariable and:[ self entity isClassInstanceVariable ]! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 10/10/2011 15:20'!
isClassVariableChange

	^ self entity isVariable and:[ self entity isClassVariable ]! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 5/17/2011 12:39'!
isCommentChange

	^self entity isComment! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 10/10/2011 15:07'!
isElementChange
	"Verifies class elements"

	^self isMethodChange
		or:[ self isVariableChange 
		or:[ self isCommentChange 
		or:[ self isAssociationChange ] ] ]! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 5/17/2011 12:43'!
isGlobalVariableChange

	^self entity isGlobalVariable! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 5/17/2011 12:58'!
isInheritanceChange

	^self entity isInheritance! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 10/10/2011 15:20'!
isInstanceVariableChange

	^ self entity isVariable and:[ self entity isInstanceVariable ]! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 5/17/2011 12:57'!
isInvocationChange

	^self entity isInvocation! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 1/11/2012 16:21'!
isMetaclassChange
	"Applicable for metaclasses of traits too"

	^self entity isMeta! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 5/17/2011 12:40'!
isMethodChange

	^self entity isMethod! !

!JETChange methodsFor: 'testing kind of changes' stamp: 'VeronicaUquillas 7/26/2011 15:18'!
isModification

	^false! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 5/17/2011 12:58'!
isPackageChange

	^self entity isPackage! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 5/17/2011 12:45'!
isPoolChange

	^self entity isPool! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 10/10/2011 15:20'!
isPoolVariableChange

	^ self entity isVariable and:[ self entity isPoolVariable ]! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 5/17/2011 12:57'!
isReferenceChange

	^self entity isReference! !

!JETChange methodsFor: 'testing kind of changes' stamp: 'VeronicaUquillas 7/13/2011 15:37'!
isRemoval

	^false! !

!JETChange methodsFor: 'testing kind of changes' stamp: 'VeronicaUquillas 7/13/2011 15:43'!
isRenaming

	^false! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 5/17/2011 12:40'!
isTraitChange

	^self entity isTrait! !

!JETChange methodsFor: 'testing entity types' stamp: 'VeronicaUquillas 10/18/2011 15:36'!
isVariableChange

	^ self entity isVariable! !

!JETChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 10/10/2011 16:02'!
name

	^ entity name! !

!JETChange methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/8/2011 19:10'!
numberOfChangesRelation

	 ^ 'Ch. ', self numberOfGlobalChanges asString, ' / ', self numberOfFutureChanges asString ! !

!JETChange methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/8/2011 19:09'!
numberOfFutureChanges 

	^ self allSuccessors size! !

!JETChange methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/8/2011 19:09'!
numberOfGlobalChanges 

	^ self withAllPredecessorsAndSuccessors size! !

!JETChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/17/2011 15:22'!
parent
	"Retrieves the entity in which the receiver is defined.
	method, variable, comment -> class
	invocation, access, reference, comment -> method"
	^self isElementChange
		ifTrue: [ self entity parent ]
		ifFalse:[ nil ]! !

!JETChange methodsFor: 'printing' stamp: 'VeronicaUquillas 7/18/2011 12:48'!
printOn: aStream 

	aStream nextPutAll: entity fullName! !

!JETChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/8/2011 19:07'!
withAllPredecessorsAndSuccessors
	
	^ (OrderedCollection new)
		addAll: self allSuccessors;
		add: self;
		addAll: self allPredecessors;
		yourself! !

JETChange subclass: #JETModifiedChange
	instanceVariableNames: 'obsoleteEntity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETModifiedChange classSide methodsFor: 'class initialization' stamp: 'VeronicaUquillas 7/13/2011 15:33'!
of: oldHistory to: newHistory

	^ self new 
		obsoleteEntity: oldHistory;
		substituteEntity: newHistory! !

!JETModifiedChange methodsFor: 'comparing' stamp: 'VeronicaUquillas 11/28/2011 16:30'!
= aRGModifiedChange

	^self class = aRGModifiedChange class
		and:[ self substituteEntity = aRGModifiedChange substituteEntity 
		and:[ self obsoleteEntity = aRGModifiedChange obsoleteEntity ] ]! !

!JETModifiedChange methodsFor: 'testing' stamp: 'VeronicaUquillas 12/8/2011 14:03'!
canHaveDependencies

	^ self entity canHaveDependencies 
		ifTrue: [ self obsoleteEntity mayHaveDependenciesRelatedTo: self entity ]
		ifFalse:[ false ]! !

!JETModifiedChange methodsFor: 'testing' stamp: 'VeronicaUquillas 10/10/2011 16:52'!
hasChangedDefinitionSource

	self isClassChange ifTrue: [
		^ self obsoleteEntity definitionSource ~= self substituteEntity definitionSource ].
	^ false! !

!JETModifiedChange methodsFor: 'testing' stamp: 'VeronicaUquillas 10/10/2011 16:44'!
hasChangedSourceCode

	self isMethodChange ifTrue: [
		^ self obsoleteEntity sourceCode ~= self substituteEntity sourceCode ].
	^ false! !

!JETModifiedChange methodsFor: 'comparing' stamp: 'VeronicaUquillas 11/28/2011 16:29'!
hash

	^self class hash bitXor: (self substituteEntity hash bitXor: self obsoleteEntity hash)! !

!JETModifiedChange methodsFor: 'testing' stamp: 'VeronicaUquillas 7/26/2011 15:18'!
isModification 

	^true! !

!JETModifiedChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/17/2011 13:19'!
obsoleteEntity

	^obsoleteEntity ! !

!JETModifiedChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/17/2011 13:18'!
obsoleteEntity: aRGObject

	obsoleteEntity:= aRGObject ! !

!JETModifiedChange methodsFor: 'printing' stamp: 'VeronicaUquillas 7/18/2011 12:50'!
printOn: aStream 

	super printOn: aStream.
	aStream nextPutAll: ' <modified>'! !

!JETModifiedChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/17/2011 15:34'!
substituteEntity

	^self entity ! !

!JETModifiedChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/17/2011 15:34'!
substituteEntity: aRGObject

	self entity: aRGObject ! !

JETChange subclass: #JETRemovedChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETRemovedChange classSide methodsFor: 'class initialization' stamp: 'VeronicaUquillas 7/13/2011 15:32'!
of: aRGHistory

	^ self new 
		entity: aRGHistory! !

!JETRemovedChange methodsFor: 'comparing' stamp: 'VeronicaUquillas 11/30/2011 11:22'!
= aRGRemovedChange

	^self class = aRGRemovedChange class
		and:[ self entity = aRGRemovedChange entity ]! !

!JETRemovedChange methodsFor: 'testing' stamp: 'VeronicaUquillas 12/8/2011 13:50'!
canHaveDependencies

	^ false! !

!JETRemovedChange methodsFor: 'comparing' stamp: 'VeronicaUquillas 11/28/2011 16:30'!
hash 

	^self class hash bitXor: self entity hash! !

!JETRemovedChange methodsFor: 'testing' stamp: 'VeronicaUquillas 7/13/2011 15:38'!
isRemoval

	^true! !

!JETRemovedChange methodsFor: 'printing' stamp: 'VeronicaUquillas 7/18/2011 12:50'!
printOn: aStream 

	super printOn: aStream.
	aStream nextPutAll: ' <removed>'! !

JETChange subclass: #JETRenamedChange
	instanceVariableNames: 'oldName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETRenamedChange methodsFor: 'testing' stamp: 'VeronicaUquillas 7/13/2011 15:39'!
isRenaming

	^true! !

!JETRenamedChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/17/2011 15:36'!
newName

	^self entity name! !

!JETRenamedChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/17/2011 15:00'!
oldName

	^oldName ! !

!JETRenamedChange methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/17/2011 15:01'!
oldName: aSymbol

	oldName := aSymbol ! !

!JETRenamedChange methodsFor: 'printing' stamp: 'VeronicaUquillas 7/18/2011 12:50'!
printOn: aStream 

	super printOn: aStream.
	aStream nextPutAll: ' <renamed>'! !

RGObject subclass: #JETDependency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

JETDependency subclass: #JETChangeDependencies
	instanceVariableNames: 'change delta dependentDeltas fuzzyDeltas neededDeltas externalDependencies changeDependencies missingDependencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETChangeDependencies classSide methodsFor: 'testing' stamp: 'VeronicaUquillas 11/25/2011 14:05'!
isDependencyGroup: aSymbol
	
	^ aSymbol = #references or:[ aSymbol = #invocations or:[ aSymbol = #superclass ] ]! !

!JETChangeDependencies classSide methodsFor: 'testing' stamp: 'VeronicaUquillas 11/25/2011 15:00'!
isPossibleToUpdateMap: anObject

	^ (self isDependencyGroup: anObject) not and:[ anObject isSymbol or:[ anObject isDependency ] ]! !

!JETChangeDependencies methodsFor: 'comparing' stamp: 'VeronicaUquillas 8/9/2012 16:04'!
= aRGSubChangeDependency

	^ self class = aRGSubChangeDependency class
		and:[ delta = aRGSubChangeDependency delta 
		and:[ change = aRGSubChangeDependency change ] ]! !

!JETChangeDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 12/2/2011 10:44'!
addDependentDelta: aRGSubChangeDependency
	|  sdelta |
	
	sdelta := aRGSubChangeDependency delta.
	self addSubDependency: aRGSubChangeDependency.
	sdelta = delta ifTrue: [ ^ self ].
	dependentDeltas 
		at: sdelta 
		ifPresent:[ :d| d add: aRGSubChangeDependency ] 
		ifAbsent:[ (dependentDeltas at: sdelta put: OrderedCollection new) add: aRGSubChangeDependency ]			! !

!JETChangeDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:02'!
addExternalClass: aRGTHistory

	self externalDependencies 
		addClass: aRGTHistory! !

!JETChangeDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 12/2/2011 01:09'!
addFuzzyDelta: aRGSubChangeDependency
	|  sdelta |
	
	sdelta := aRGSubChangeDependency delta.
	sdelta = delta ifTrue: [ ^ self ].
	delta addOutgoingFuzzyDelta: sdelta.
	fuzzyDeltas 
		at: sdelta 
		ifPresent:[ :d| d add: aRGSubChangeDependency ] 
		ifAbsent:[ (fuzzyDeltas at: sdelta put: OrderedCollection new) add: aRGSubChangeDependency ]	! !

!JETChangeDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:04'!
addMissingInvocation: aRGTHistory

	self missingDependencies 
		addInvocation: aRGTHistory! !

!JETChangeDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 12/1/2011 22:10'!
addNeededDelta: aRGSubChangeDependency
	|  sdelta |
	
	sdelta := aRGSubChangeDependency delta.
	sdelta = delta ifTrue: [ ^ self ].
	delta addOutgoingNeededDelta: sdelta.
	neededDeltas 
		at: sdelta 
		ifPresent:[ :d| d add: aRGSubChangeDependency ] 
		ifAbsent:[ (neededDeltas at: sdelta put: OrderedCollection new) add: aRGSubChangeDependency ]! !

!JETChangeDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
addSubDependency: aRGSubChangeDependency

	changeDependencies add: aRGSubChangeDependency! !

!JETChangeDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 12/2/2011 13:00'!
atInvocationNamed: aSymbol put: aCollection

	aCollection isEmpty ifTrue: [ ^ self ].
	aCollection do:[ :each| 
		each type: #invocations; key: aSymbol.
		self addDependentDelta: each ].
	aCollection size = 1 ifTrue: [
		self addNeededDelta: aCollection first ].
	aCollection size > 1 ifTrue: [ 
		aCollection do:[ :each| self addFuzzyDelta: each ] ].! !

!JETChangeDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 12/2/2011 13:00'!
atReferenceNamed: aSymbol put: anObject

	anObject isDependency ifTrue:[
		anObject type: #references; key: aSymbol. 
		self addDependentDelta: anObject.
		self addNeededDelta: anObject ].! !

!JETChangeDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 1/20/2012 13:22'!
atSuperclassNamed: aSymbol put: anObject

	anObject isDependency ifTrue: [
		anObject type: #superclass; key: aSymbol. 
		self addDependentDelta: anObject.
		self addNeededDelta: anObject ]! !

!JETChangeDependencies methodsFor: 'calculating dependencies' stamp: 'VeronicaUquillas 12/9/2011 11:21'!
calculateChangedDependencies

	change isClassChange ifTrue: [  
		self changedDependenciesOfClass ].
	change isMethodChange ifTrue: [ 
		self changedDependenciesOfMethod ].! !

!JETChangeDependencies methodsFor: 'calculating dependencies' stamp: 'VeronicaUquillas 12/2/2011 00:59'!
calculateDependencies

	change isClassChange ifTrue: [  
		self dependenciesOfClass ].
	change isMethodChange ifTrue: [ 
		self dependenciesOfMethod ].! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 13:31'!
change

	^ change! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 13:31'!
change: aRGChange

	change := aRGChange! !

!JETChangeDependencies methodsFor: 'calculating dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:11'!
changedDependenciesOfClass
	"For a class we estabished the following dependencies:
		1) superclass"
	| history dep superclass |
	
	history := self change entity.
	
	history isMeta ifFalse: [
		(change isAddition ifTrue: [ true ] ifFalse:[ self change obsoleteEntity superclassDiffersTo: history ]) ifTrue: [
			superclass := history superclass.
			(superclass notNil and:[ superclass isExternal ])
			ifTrue: [ 
				self addExternalClass: superclass.
				self atSuperclassNamed: superclass name asSymbol put: superclass ]
			ifFalse:[
				dep := delta dependentDeltaIncludingMergedChange: superclass.
				dep ifNotNil:[ 
					dep parent: self.
					self atSuperclassNamed: superclass name asSymbol put: dep ] ] ] ]! !

!JETChangeDependencies methodsFor: 'calculating dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:42'!
changedDependenciesOfMethod
	"For a method we estabished the following dependencies:
		1) invocations
		2) references"
	|  depsDeltas history |
	
	change isRemoval ifTrue: [ ^ self ].
	history := self change entity.
	
	(change isAddition 
		ifTrue: [ history invocations ]
		ifFalse:[ self change obsoleteEntity changedInvocationsTo:  self change entity ]) do:[ :each|		
		depsDeltas := 
			each candidates collect: [ :mth| delta dependentDeltaIncludingMergedChange: mth ] thenSelect:[ :dep| dep notNil ].
		depsDeltas do:[ :dep| dep parent: self ].
		(depsDeltas isEmpty and:[ each isStatic not ])  
			ifTrue: [ self missingDependencies addInvocation: each message ].
		self atInvocationNamed: each keyName asSymbol put: depsDeltas asOrderedCollection ].
	
	(change isAddition 
		ifTrue: [ history references ]
		ifFalse:[ self change obsoleteEntity changedReferencesTo:  self change entity ]) do: [ :each| | targetRef dep |
		targetRef := each target.
		targetRef isExternal
			ifTrue: [ 
				self addExternalClass: targetRef.
				self atReferenceNamed: targetRef name asSymbol put: targetRef ]
			ifFalse:[ 
				dep := delta dependentDeltaIncludingMergedChange: targetRef.
				dep ifNotNil:[ 
					dep parent: self.
					self atReferenceNamed: targetRef name asSymbol put: dep ] ] ]! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/2/2011 10:57'!
childrenDependenciesOf: anObject
	| value map |
	
	map := self dependenciesMap.
	anObject isSymbol ifTrue: [ 
		(map includesKey: anObject) 
			ifTrue: [ value := map at: anObject. 
					anObject = #references 
						ifTrue: [ value := self sortDependenciesOfReferences: (self rejectFalsePositivesDependencies: value values) ].			
					anObject = #superclass 
						ifTrue: [ (value isDependency and:[ value isFalsePositive ])
									ifTrue: [ value := #() ]
									ifFalse:[ value := OrderedCollection with: value ]	].
					^ value isDictionary 
						ifTrue: [ (value select:[ :sub| (self rejectFalsePositives: sub) notEmpty ]) keys asSortedCollection ] 
						ifFalse:[ value ] ]
			ifFalse:[ (value := map values detect:[ :sub| sub isDictionary and:[ sub includesKey: anObject ] ] ifNone:[ nil ]) isNil
						ifFalse:[ 
							value := value at: anObject.
							value isCollection 
								ifTrue: [ ^ self sortDependenciesOfInvocations: (self rejectFalsePositives: value) ] ] ] ].
	^#()! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 15:05'!
childrenDependenciesOf: anObject andDelta: aRGSnapshotDelta 
	| value deltaDependencies |
	
	anObject isSymbol ifTrue: [ 
		deltaDependencies := self dependenciesMapOfDelta: aRGSnapshotDelta.
		(deltaDependencies includesKey: anObject) 
			ifTrue: [ value := deltaDependencies at: anObject. 
					anObject = #references 
						ifTrue: [ value := value values ].
					^ value isDictionary 
						ifTrue: [ value keys asSortedCollection ] 
						ifFalse:[ value asOrderedCollection ] ]
			ifFalse:[ (value := deltaDependencies values detect:[ :sub| sub isDictionary and:[ sub includesKey: anObject ] ] ifNone:[ nil ]) isNil
						ifFalse:[ (value at: anObject) isEmpty 
									ifFalse:[ ^ self sortDeltas: (value at: anObject) ] ] ] ].
	^ #()! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 13:13'!
childrenExcludedDependenciesOf: anObject
	| value excludedDependencies |
	
	anObject isSymbol ifTrue: [
		excludedDependencies := self excludedDependenciesMap.
		(excludedDependencies includesKey: anObject) 
		ifTrue: [ value := excludedDependencies at: anObject. 
				^ value isDictionary 
					ifTrue: [ value keys asSortedCollection ] 
					ifFalse:[ value asOrderedCollection ] ]
		ifFalse:[ (value := excludedDependencies values detect:[ :sub| sub isDictionary and:[ sub includesKey: anObject ] ] ifNone:[ nil ]) isNil
					ifFalse:[ 
						value := value at: anObject.
						value isCollection ifTrue: [ ^ self sortDependenciesOfInvocations: value ] ] ] ].
	^ #()! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 13:31'!
delta

	^ delta! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 13:31'!
delta: aRGSnapshotDelta

	delta := aRGSnapshotDelta! !

!JETChangeDependencies methodsFor: 'testing' stamp: 'VeronicaUquillas 12/2/2011 00:33'!
dependOn: aRGSnapshotDelta 

	^ self dependentDeltas includes: aRGSnapshotDelta ! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:01'!
dependenciesMap
	| map invSubDeps refSubDeps supSubDeps |
	
	map := Dictionary new.
	invSubDeps := self invocationSubDependencies.
	refSubDeps := self referenceSubDependencies.
	supSubDeps := self superclassSubDependencies. 
	invSubDeps notEmpty ifTrue: [
		map at: #invocations put: Dictionary new.
		(invSubDeps collect:[ :each| each key ]) asSet
			do:[ :key| (map at: #invocations) at: key put: (self sortDependenciesOfInvocations: (invSubDeps select:[ :each| each key = key ]) ) ]
		].
	(refSubDeps notEmpty or:[ externalDependencies notNil ])
		 ifTrue: [
			map at: #references put: Dictionary new.
			refSubDeps do:[ :each|
				(map at: #references) at: each key put: each ].
			externalDependencies notNil ifTrue:[ 
				externalDependencies classes do:[ :each|
					(map at: #references) at: each name put: each ] ]
		].
	supSubDeps notEmpty ifTrue: [
		map at: #superclass put: supSubDeps first..
		].	
	^ map	! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 8/9/2012 16:26'!
dependenciesMapOfDelta: aRGSnapshotDelta 
	| map invSubDeps refSubDeps supSubDeps |
	
	map := Dictionary new.
	invSubDeps := self invocationSubDependenciesOf: aRGSnapshotDelta.
	refSubDeps := self referenceSubDependenciesOf: aRGSnapshotDelta.
	supSubDeps := self superclassSubDependenciesOf: aRGSnapshotDelta.
	invSubDeps notEmpty ifTrue: [
		map at: #invocations put: Dictionary new.
		(invSubDeps collect:[ :each| each key ]) asSet
			do:[ :key| (map at: #invocations) at: key put: (self sortDependenciesOfInvocations: (invSubDeps select:[ :each| each key = key ]) ) ]
		].
	refSubDeps notEmpty ifTrue: [
		map at: #references put: Dictionary new.
		refSubDeps do:[ :each|
			(map at: #references) at: each key put: each ].
		].
	supSubDeps notEmpty ifTrue: [
		map at: #superclass put: supSubDeps first.
		].	
	^ map	! !

!JETChangeDependencies methodsFor: 'calculating dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:11'!
dependenciesOfClass
	"For a class we estabished the following dependencies:
		1) superclass"
	| history dep superclass |
	
	history := self change entity.
	
	history isMeta ifFalse: [
		superclass := history superclass.
		(superclass notNil and:[ superclass isExternal ])
			ifTrue: [ 
				self addExternalClass: superclass.
				self atSuperclassNamed: superclass name asSymbol put: superclass ]
			ifFalse:[
				dep := delta dependentDeltaIncludingMergedChange: superclass.
				dep ifNotNil:[ 
					dep parent: self.
					self atSuperclassNamed: superclass name asSymbol put: dep ] ] ]! !

!JETChangeDependencies methodsFor: 'calculating dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:41'!
dependenciesOfMethod
	"For a method we estabished the following dependencies:
		1) invocations
		2) references"
	|  depsDeltas history |
	
	change isRemoval ifTrue: [ ^ self ].
	history := self change entity.
	
	history invocations do:[ :each|
		depsDeltas := 
			each candidates collect: [ :mth| delta dependentDeltaIncludingMergedChange: mth ] thenSelect:[ :dep| dep notNil ].
		depsDeltas do:[ :dep| dep parent: self ].
		(depsDeltas isEmpty and:[ each isStatic not ]) 
			ifTrue: [ self missingDependencies addInvocation: each message ].
		self atInvocationNamed: each keyName asSymbol put: depsDeltas asOrderedCollection ].
	
	history references do: [ :each| | targetRef dep |
		targetRef := each target.
		targetRef isExternal
			ifTrue: [ 
				self addExternalClass: targetRef.
				self atReferenceNamed: targetRef name asSymbol put: targetRef ]
			ifFalse:[ 
				dep := delta dependentDeltaIncludingMergedChange: targetRef.
				dep ifNotNil:[ 
					dep parent: self.
					self atReferenceNamed: targetRef name asSymbol put: dep ] ] ]! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 23:18'!
dependentDeltas
	
	^ self extractDeltasOf: dependentDeltas ! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 14:57'!
dependentDeltasMap
	
	^ dependentDeltas ! !

!JETChangeDependencies methodsFor: 'filtering dependencies' stamp: 'VeronicaUquillas 11/25/2011 15:39'!
excludeDependenciesGroupedAs: aSymbol 

	self updateDependenciesGroupedAs: aSymbol with: #excludeFromChangeDependency.! !

!JETChangeDependencies methodsFor: 'filtering dependencies' stamp: 'VeronicaUquillas 12/2/2011 01:11'!
excludeSubDependencyFromDeltas: aRGSubChangeDependency
	| sdelta |
	
	sdelta := aRGSubChangeDependency delta.
	(neededDeltas includesKey: sdelta) ifTrue: [ 
		(neededDeltas at: sdelta) remove: aRGSubChangeDependency ifAbsent:[].
		delta resetOutgoingNeededDeltas ].
	(fuzzyDeltas includesKey: sdelta) ifTrue: [ 
		| fdeltas |
		fdeltas := fuzzyDeltas at: sdelta.
		fdeltas remove: aRGSubChangeDependency ifAbsent:[].
		delta resetOutgoingFuzzyDeltas.
		fdeltas size = 1 ifTrue: [ 
			(self includedSubDependencies: fdeltas first) size = 1 ifTrue: [ 
				neededDeltas at: sdelta put: fdeltas.
				delta resetOutgoingNeededDeltas.
				fuzzyDeltas removeKey: sdelta ] ] ].
	(dependentDeltas includesKey: sdelta) ifTrue: [ 
		(dependentDeltas at: sdelta) remove: aRGSubChangeDependency ifAbsent:[] ].! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/2/2011 10:41'!
excludedDependenciesMap 
	| map invSubDeps refSubDeps supSubDeps |
	
	map := Dictionary new.
	invSubDeps := self excludedInvocationSubDependencies.
	refSubDeps := self excludedReferenceSubDependencies.
	supSubDeps := self excludedSuperclassSubDependencies. 
	invSubDeps notEmpty ifTrue: [
		map at: #invocations put: Dictionary new.
		(invSubDeps collect:[ :each| each key ]) asSet
			do:[ :key| (map at: #invocations) at: key put: (self sortDependenciesOfInvocations: (invSubDeps select:[ :each| each key = key ]) ) ]
		].
	refSubDeps notEmpty ifTrue: [
		map at: #references put: Dictionary new.
		refSubDeps do:[ :each|
			(map at: #references) at: each key put: each ].
		].
	supSubDeps notEmpty ifTrue: [
		map at: #superclass put: supSubDeps first..
		].	
	^ map	! !

!JETChangeDependencies methodsFor: 'accessing subdependencies' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
excludedInvocationSubDependencies

	^ changeDependencies select:[ :each| each type = #invocations and:[ each isFalsePositive ] ]! !

!JETChangeDependencies methodsFor: 'accessing subdependencies' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
excludedReferenceSubDependencies

	^ changeDependencies select:[ :each| each type = #references and:[ each isFalsePositive ] ]! !

!JETChangeDependencies methodsFor: 'accessing subdependencies' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
excludedSuperclassSubDependencies

	^ changeDependencies select:[ :each| each type = #superclass and:[ each isFalsePositive ] ]! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:11'!
externalDependencies

	^ externalDependencies ifNil:[ 
		externalDependencies := JETExternalDependencies new
									parent: self ]! !

!JETChangeDependencies methodsFor: 'private' stamp: 'VeronicaUquillas 7/7/2012 08:52'!
externalImplementorsOf: aString

	^ SystemNavigation default allClassesImplementing: aString! !

!JETChangeDependencies methodsFor: 'private' stamp: 'VeronicaUquillas 11/26/2011 23:59'!
extractDeltasOf: aDictionary

	^ (aDictionary select:[ :each| each notEmpty ]) keys asOrderedCollection! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/1/2011 16:46'!
fullName

	^ self 
		annotationNamed: self class fullNameKey 
		ifAbsentPut: [ self change fullName, ' [', self delta minimalName, ']' ]! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 23:18'!
fuzzyDeltas

	^ self extractDeltasOf: fuzzyDeltas ! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 14:56'!
fuzzyDeltasMap

	^ fuzzyDeltas ! !

!JETChangeDependencies methodsFor: 'testing' stamp: 'VeronicaUquillas 7/7/2012 00:01'!
hasDependencies

	^ self includedSubDependencies notEmpty or:[ externalDependencies notNil ]! !

!JETChangeDependencies methodsFor: 'testing' stamp: 'VeronicaUquillas 11/28/2011 17:48'!
hasDependentDeltas

	^ self dependentDeltasMap notEmpty ! !

!JETChangeDependencies methodsFor: 'testing' stamp: 'VeronicaUquillas 7/7/2012 00:01'!
hasExternalDependency

	^ externalDependencies notNil! !

!JETChangeDependencies methodsFor: 'testing' stamp: 'VeronicaUquillas 7/7/2012 02:02'!
hasMissingDependencies

	^ missingDependencies notNil
		and:[ missingDependencies invocations notEmpty ]! !

!JETChangeDependencies methodsFor: 'comparing' stamp: 'VeronicaUquillas 8/9/2012 16:05'!
hash

	^ self class hash bitXor: (delta hash bitXor: change hash)! !

!JETChangeDependencies methodsFor: 'filtering dependencies' stamp: 'VeronicaUquillas 11/25/2011 15:39'!
includeDependenciesGroupedAs: aSymbol 

	self updateDependenciesGroupedAs: aSymbol with: #includeFromChangeDependency! !

!JETChangeDependencies methodsFor: 'filtering dependencies' stamp: 'VeronicaUquillas 12/2/2011 01:12'!
includeSubDependencyFromDeltas: aRGSubChangeDependency
	| sdelta |
	
	sdelta := aRGSubChangeDependency delta.
	(neededDeltas includesKey: sdelta) ifTrue: [ | ndeltas move |
		ndeltas := neededDeltas at: sdelta.
		ndeltas add: aRGSubChangeDependency.
		delta resetOutgoingNeededDeltas.
		ndeltas size > 1 ifTrue: [ 
			move := false.
			ndeltas do:[ :each|
				(self includedSubDependencies: each) size > 1
					ifTrue: [ move := true ] ].
			move ifTrue: [
				fuzzyDeltas at: sdelta put: ndeltas.
				delta resetOutgoingFuzzyDeltas.
				neededDeltas removeKey: sdelta  ] ] ].
	(fuzzyDeltas includesKey: sdelta) ifTrue: [ 
		(fuzzyDeltas at: sdelta) add: aRGSubChangeDependency ].
	(dependentDeltas includesKey: sdelta) ifTrue: [ | ddeltas |
		ddeltas := dependentDeltas at: sdelta.
		ddeltas add: aRGSubChangeDependency.
		self flag: 'this should not be necessary'.
		ddeltas do:[ :each|
			(self includedSubDependencies: each) size = 1
				ifTrue: [ neededDeltas at: sdelta put: ddeltas.
					     delta resetOutgoingNeededDeltas ] ]  ]! !

!JETChangeDependencies methodsFor: 'accessing subdependencies' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
includedSubDependencies

	^ changeDependencies select:[ :each| each isFalsePositive not ]! !

!JETChangeDependencies methodsFor: 'testing' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
includedSubDependencies: aRGSubChangeDependency

	^ changeDependencies select:[ :each| each type = aRGSubChangeDependency type and:[ each key = aRGSubChangeDependency key and:[ each isFalsePositive not ] ] ]! !

!JETChangeDependencies methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 12/2/2011 01:00'!
initialize 

	super initialize.
	self resetCollections.! !

!JETChangeDependencies methodsFor: 'accessing subdependencies' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
invocationSubDependencies

	^ changeDependencies select:[ :each| each type = #invocations and:[ each isFalsePositive not ] ]! !

!JETChangeDependencies methodsFor: 'accessing subdependencies' stamp: 'VeronicaUquillas 12/2/2011 10:15'!
invocationSubDependenciesOf: aRGSnapshotDelta 

	^ self invocationSubDependencies select:[  :each| each delta = aRGSnapshotDelta ]! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:11'!
missingDependencies

	^ missingDependencies ifNil:[ 
		missingDependencies := JETMissingDependencies new
									parent: self ]! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 10/10/2012 14:01'!
missingDependenciesMap
	"from the missing dependencies in the stream build a map with the ones that have not implementors in the working copy"
	| map extImplementors |
	
	map := Dictionary new.
	self hasMissingDependencies ifTrue: [
		map at: #invocations put: Dictionary new.
		self missingDependencies invocations do:[ :each|			
			extImplementors := (self externalImplementorsOf: each).
			extImplementors isEmpty
				ifTrue: [ (map at: #invocations) at: each put: Dictionary new. ].					
			"(JETMissingDependencies ignoreMessage: each) ifFalse:[
				(map at: #invocations) at: each put: (self externalImplementorsOf: each) ]" ].
		(map at: #invocations) isEmpty 
			ifTrue: [ ^ Dictionary new ] ] .
	^ map! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 10/10/2012 14:17'!
missingDependenciesOf: anObject
	| value map |
	
	map := self missingDependenciesMap.
	anObject isSymbol ifTrue: [ 
		(map includesKey: anObject) 
			ifTrue: [ value := map at: anObject. 
					^ value isDictionary 
					ifTrue: [ value keys asSortedCollection ] 
					ifFalse:[ value asOrderedCollection ] ]
			ifFalse:[ (value := map values detect:[ :sub| sub isDictionary and:[ sub includesKey: anObject ] ] ifNone:[ nil ]) isNil
					ifFalse:[ 
						value := value at: anObject.
						(value isCollection and:[ value notEmpty ]) ifTrue: [ ^ self sortImplementors: value ] ] ] ].
	^ #()
	! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 23:19'!
neededDeltas
	
	^ self extractDeltasOf: neededDeltas ! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 14:56'!
neededDeltasMap
	
	^ neededDeltas ! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/1/2011 18:27'!
potentialDeltas
	
	^ self fuzzyDeltas difference: self neededDeltas ! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/1/2011 18:27'!
potentialDeltasMap
	| map |
	map := Dictionary new.
	map addAll: self fuzzyDeltasMap.
	self neededDeltas do:[ :each|
		(map includesKey: each) ifTrue:[ map removeKey: each ] ].
	^ map! !

!JETChangeDependencies methodsFor: 'printing' stamp: 'VeronicaUquillas 11/25/2011 13:36'!
printOn: aStream 

	aStream nextPutAll: self fullName.! !

!JETChangeDependencies methodsFor: 'accessing subdependencies' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
referenceSubDependencies

	^ changeDependencies select:[ :each| each type = #references and:[ each isFalsePositive not ] ]! !

!JETChangeDependencies methodsFor: 'accessing subdependencies' stamp: 'VeronicaUquillas 12/2/2011 10:15'!
referenceSubDependenciesOf: aRGSnapshotDelta 

	^ self referenceSubDependencies select:[ :each| each delta = aRGSnapshotDelta ]! !

!JETChangeDependencies methodsFor: 'private' stamp: 'VeronicaUquillas 11/26/2011 23:17'!
rejectFalsePositives: aCollection

	^ aCollection reject:[ :ref | ref isFalsePositive ]! !

!JETChangeDependencies methodsFor: 'private' stamp: 'VeronicaUquillas 11/26/2011 23:17'!
rejectFalsePositivesDependencies: aCollection

	^ aCollection reject:[ :ref | ref isDependency and:[ ref isFalsePositive ] ]! !

!JETChangeDependencies methodsFor: 'calculating dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
removeDependenciesOf: aRGSnapshotDelta 

	fuzzyDeltas removeKey: aRGSnapshotDelta ifAbsent: []. 
	dependentDeltas removeKey: aRGSnapshotDelta ifAbsent: []. 
	neededDeltas removeKey: aRGSnapshotDelta ifAbsent: []. 
	changeDependencies := changeDependencies reject:[ :each| each delta = aRGSnapshotDelta ].! !

!JETChangeDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
removeSubDependency: aRGSubChangeDependency

	changeDependencies remove: aRGSubChangeDependency! !

!JETChangeDependencies methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
resetCollections

	dependentDeltas := Dictionary new.
	fuzzyDeltas := Dictionary new.
	neededDeltas := Dictionary new.
	changeDependencies := OrderedCollection new.! !

!JETChangeDependencies methodsFor: 'sorting' stamp: 'VeronicaUquillas 11/28/2011 11:12'!
sortDeltas: aCollection

	^ aCollection sort: [:e1 :e2 | e1 fullName <= e2 fullName ]! !

!JETChangeDependencies methodsFor: 'sorting' stamp: 'VeronicaUquillas 11/26/2011 23:24'!
sortDependenciesOfInvocations: aCollection

	^ aCollection sort: [:e1 :e2 | e1 change fullName <= e2 change fullName ]! !

!JETChangeDependencies methodsFor: 'sorting' stamp: 'VeronicaUquillas 11/26/2011 23:24'!
sortDependenciesOfReferences: aCollection

	^ aCollection sort: [:e1 :e2 | e1 name <= e2 name]! !

!JETChangeDependencies methodsFor: 'sorting' stamp: 'VeronicaUquillas 7/7/2012 08:58'!
sortImplementors: aCollection

	^ aCollection sort: [:e1 :e2 | e1 name <= e2 name ]! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
subChangeDependencies

	^ changeDependencies! !

!JETChangeDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/6/2011 14:45'!
subDependencyDependingOn: aRGSnapshotDelta 

	^ self subChangeDependencies select:[ :each| each delta = aRGSnapshotDelta ]! !

!JETChangeDependencies methodsFor: 'accessing subdependencies' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
superclassSubDependencies

	^ changeDependencies select:[ :each| each type = #superclass and:[ each isFalsePositive not ] ]! !

!JETChangeDependencies methodsFor: 'accessing subdependencies' stamp: 'VeronicaUquillas 12/2/2011 10:16'!
superclassSubDependenciesOf: aRGSnapshotDelta 

	^ self superclassSubDependencies select:[ :each| each delta = aRGSnapshotDelta ]! !

!JETChangeDependencies methodsFor: 'filtering dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:15'!
updateDependenciesGroupedAs: aSymbol with: selector
	| subDeps |
	
	subDeps := changeDependencies select:[ :each| each type = aSymbol ].
	subDeps ifNil:[ changeDependencies select:[ :each| each key = aSymbol ] ].			
	subDeps do:[ :each| each perform: selector ]! !

JETDependency subclass: #JETChangeDependency
	instanceVariableNames: 'change delta parent type key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETChangeDependency classSide methodsFor: 'annotations' stamp: 'VeronicaUquillas 11/25/2011 13:09'!
isFalsePositiveKey

	^#isFalsePositive! !

!JETChangeDependency methodsFor: 'comparing' stamp: 'VeronicaUquillas 7/7/2012 00:07'!
= aRGSubChangeDependency

	^ self class = aRGSubChangeDependency class
		and:[ delta = aRGSubChangeDependency delta 
		and:[ change = aRGSubChangeDependency change 
		and:[ parent = aRGSubChangeDependency parent ] ] ]! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 13:37'!
change

	^ change! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 13:38'!
change: aRGChange

	change := aRGChange! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 13:38'!
delta

	^ delta! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 13:38'!
delta: aRGSnapshotDelta

	delta := aRGSnapshotDelta! !

!JETChangeDependency methodsFor: 'filtering dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:08'!
excludeFromChangeDependency

	self isFalsePositive: true.
	self parent excludeSubDependencyFromDeltas: self! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/1/2011 22:31'!
fullName

	^ self 
		annotationNamed: self class fullNameKey 
		ifAbsentPut: [ self change fullName, ' [', self delta minimalName, ']' ]! !

!JETChangeDependency methodsFor: 'comparing' stamp: 'VeronicaUquillas 7/7/2012 00:07'!
hash

	^ self class hash bitXor: (delta hash bitXor: (change hash bitXor: parent hash ))! !

!JETChangeDependency methodsFor: 'filtering dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:08'!
includeFromChangeDependency

	self isFalsePositive: false.
	self parent includeSubDependencyFromDeltas: self! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 13:09'!
isFalsePositive

	^ self annotationNamed: self class isFalsePositiveKey ifAbsentPut:[ false ] ! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 14:50'!
isFalsePositive: aBoolean

	self annotationNamed: self class isFalsePositiveKey put: aBoolean! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 12:50'!
key

	^ key! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 12:51'!
key: aSymbol

	key := aSymbol! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:07'!
parent

	^ parent! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:07'!
parent: aRGChangeDependencies

	parent := aRGChangeDependencies! !

!JETChangeDependency methodsFor: 'printing' stamp: 'VeronicaUquillas 11/28/2011 12:52'!
printOn: aStream 

	aStream nextPutAll: '<sub-change><', type, '> ', self fullName! !

!JETChangeDependency methodsFor: 'testing' stamp: 'VeronicaUquillas 7/7/2012 00:08'!
shouldBePotentialDependency

	^ (self parent includedSubDependencies: self) size > 1! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 12:50'!
type

	^ type! !

!JETChangeDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 12:51'!
type: aSymbol

	type := aSymbol! !

!JETDependency classSide methodsFor: 'annotations' stamp: 'VeronicaUquillas 11/25/2011 23:20'!
fullNameKey

	^#fullName! !

!JETDependency methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/25/2011 23:20'!
fullName 

	self subclassResponsibility ! !

!JETDependency methodsFor: 'testing' stamp: 'VeronicaUquillas 11/24/2011 15:20'!
isDependency

	^ true! !

JETDependency subclass: #JETExternalDependencies
	instanceVariableNames: 'parent classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETExternalDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 12/1/2011 18:32'!
addClass: aRGTHistory

	(classes includes: aRGTHistory)
		ifFalse:[ classes add: aRGTHistory ]! !

!JETExternalDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/1/2011 18:31'!
classNames

	^ classes collect:[ :each| each name ]

	! !

!JETExternalDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/2/2011 10:11'!
classes

	^ classes

	! !

!JETExternalDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:12'!
fullName

	^ self 
		annotationNamed: self class fullNameKey 
		ifAbsentPut: [ self parent fullName ]! !

!JETExternalDependencies methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 12/1/2011 18:33'!
initialize 

	super initialize.
	classes := OrderedCollection new! !

!JETExternalDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:10'!
parent

	^ parent! !

!JETExternalDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:10'!
parent: aRGChangeDependencies

	parent := aRGChangeDependencies! !

!JETExternalDependencies methodsFor: 'printing' stamp: 'VeronicaUquillas 11/25/2011 23:24'!
printOn: aStream 

	aStream nextPutAll: '<external> ', self fullName.! !

JETDependency subclass: #JETMissingDependencies
	instanceVariableNames: 'parent invocations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETMissingDependencies classSide methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 7/7/2012 09:32'!
ignoreMessage: aString
	| coreMessages |
	
	coreMessages := { #and: . #or: . #ifTrue: . #ifFalse: . #ifTrue:ifFalse: . #ifFalse:ifTrue: . #do: . #select: . #collect: . #reject .  #at: . #at:put: . #at:ifAbsent: . #at:ifAbsentPut: . #value . #value: . #, . #new . #yourself .
		#isNil . #notNil . #ifNil: . #ifNotNil: . #ifNilDo: . #ifNotNilDo: }.
	^ coreMessages includes: aString
	! !

!JETMissingDependencies methodsFor: 'adding dependencies' stamp: 'VeronicaUquillas 7/7/2012 09:21'!
addInvocation: aString

	(self class ignoreMessage: aString)
		ifFalse:[ invocations add: aString ]! !

!JETMissingDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:12'!
fullName

	^ self 
		annotationNamed: self class fullNameKey 
		ifAbsentPut: [ self parent fullName ]! !

!JETMissingDependencies methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 7/7/2012 00:28'!
initialize 

	super initialize.
	invocations := Set new! !

!JETMissingDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/6/2012 23:53'!
invocations

	^invocations! !

!JETMissingDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:09'!
parent

	^ parent! !

!JETMissingDependencies methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/7/2012 00:10'!
parent: aRGChangeDependencies

	parent := aRGChangeDependencies! !

!JETMissingDependencies methodsFor: 'printing' stamp: 'VeronicaUquillas 7/7/2012 00:36'!
printOn: aStream 

	aStream nextPutAll: '<missing> ', self fullName.! !

RGObject subclass: #JETSnapshotDelta
	instanceVariableNames: 'base target changes mergedChanges predecessors successors changeDependencies outgoingNeededDeltas outgoingFuzzyDeltas incomingNeededDeltas incomingFuzzyDeltas traversedOutgoingPotentialDeltas traversedOutgoingNeededDeltas traversedIncomingNeededDeltas traversedIncomingPotentialDeltas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETSnapshotDelta classSide methodsFor: 'annotations' stamp: 'VeronicaUquillas 11/24/2011 15:17'!
allPredecessorsKey

	^#allPredecessors! !

!JETSnapshotDelta classSide methodsFor: 'annotations' stamp: 'VeronicaUquillas 11/24/2011 15:17'!
allSuccessorsKey

	^#allSuccessors ! !

!JETSnapshotDelta classSide methodsFor: 'class initialization' stamp: 'VeronicaUquillas 10/18/2011 10:33'!
deltaFrom: baseSnapshot to: targetSnapshot

	^ self new
		deltaFrom: baseSnapshot to: targetSnapshot ! !

!JETSnapshotDelta classSide methodsFor: 'annotations' stamp: 'VeronicaUquillas 12/1/2011 18:30'!
externalNeededClassesKey

	^#externalNeededClasses ! !

!JETSnapshotDelta classSide methodsFor: 'class initialization' stamp: 'VeronicaUquillas 11/29/2011 21:56'!
from: baseSnapshot to: targetSnapshot

	^ self new
		base: baseSnapshot;
		target: targetSnapshot;
		yourself! !

!JETSnapshotDelta methodsFor: 'comparing' stamp: 'VeronicaUquillas 11/28/2011 16:34'!
= aRGSnapshotDelta 

	^ self class = aRGSnapshotDelta class
		and:[ base = aRGSnapshotDelta base 
		and:[ target = aRGSnapshotDelta target ] ]! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 12/1/2011 18:22'!
addChangeDependency: aRGChangeDependency

	changeDependencies add: aRGChangeDependency! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 12/2/2011 01:08'!
addIncomingFuzzyDelta: aRGSnapshotDelta 

	incomingFuzzyDeltas add: aRGSnapshotDelta! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 12/1/2011 22:06'!
addIncomingNeededDelta: aRGSnapshotDelta 

	incomingNeededDeltas add: aRGSnapshotDelta! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 12/2/2011 01:08'!
addOutgoingFuzzyDelta: aRGSnapshotDelta 

	outgoingFuzzyDeltas ifNil:[ outgoingFuzzyDeltas := Set new ].
	outgoingFuzzyDeltas add: aRGSnapshotDelta.
	aRGSnapshotDelta addIncomingFuzzyDelta: self! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 12/1/2011 22:21'!
addOutgoingNeededDelta: aRGSnapshotDelta 

	outgoingNeededDeltas ifNil:[ outgoingNeededDeltas := Set new ].
	outgoingNeededDeltas add: aRGSnapshotDelta.
	aRGSnapshotDelta addIncomingNeededDelta: self! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 11/8/2011 13:47'!
addPredecessor: aRGSnapshotDelta 

	predecessors add: aRGSnapshotDelta ! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 12/8/2011 16:21'!
addSuccessor: aRGSnapshotDelta 

	successors add: aRGSnapshotDelta ! !

!JETSnapshotDelta methodsFor: 'accessing changes' stamp: 'VeronicaUquillas 10/18/2011 13:22'!
additions

	^ self changes select:[ :each | each isAddition ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/2/2011 00:00'!
allIncludedPredecessors
	
	^ self allPredecessors reject:[ :each| each isExcluded ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/24/2011 15:18'!
allPredecessors
	"When requesting the predecessors, query them starting from the version in which they were defined"
	
	^ self 
		annotationNamed: self class allPredecessorsKey 
		ifAbsentPut:[ (self allPredecessors: self predecessors with: Dictionary new) values sort: self sortByTimestampDesc ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/8/2011 16:24'!
allPredecessors: predecessorsCollection with: resultCollection
	predecessorsCollection do:[ :each| 
		(resultCollection includesKey: each key) ifFalse:[
			resultCollection at: each key put: each. 
			each 
				allPredecessors: each predecessors
				with: resultCollection ] ].
			
	^resultCollection! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/8/2011 16:25'!
allSuccessors
	"When requesting the successors, query them starting from the version in which they were defined"
	
	^ self 
		annotationNamed: self class allSuccessorsKey 
		ifAbsentPut:[ (self allSuccessors: self successors with: Dictionary new) values sort: self sortByTimestampDesc ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/8/2011 16:24'!
allSuccessors: successorsCollection with: resultCollection
	successorsCollection do:[ :each| 
		(resultCollection includesKey: each key) ifFalse:[
			resultCollection at: each key put: each. 
			each 
				allSuccessors: each successors 
				with: resultCollection ] ].
			
	^resultCollection! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 10/18/2011 16:09'!
base

	^ base! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/29/2011 21:56'!
base: aRGSnapshotRepository

	base := aRGSnapshotRepository! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/2/2011 00:19'!
changeDependencies

	^ changeDependencies! !

!JETSnapshotDelta methodsFor: 'accessing changes' stamp: 'VeronicaUquillas 12/1/2011 18:22'!
changeDependencyOf: aRGChange

	^ (changeDependencies detect:[ :each| each change = aRGChange ] ifNone:[ nil ])! !

!JETSnapshotDelta methodsFor: 'generating deltas/dependencies' stamp: 'VeronicaUquillas 8/9/2012 15:20'!
changeForBaseHistory: baseHistory andTargetHistory: targetHistory

	
	(((target wasHistoryAdded: targetHistory) and:[ baseHistory isNil ]) or:[ target wasHistoryReintroduced: targetHistory ] )
		ifTrue: [ ^ (JETAddedChange of: targetHistory) ].

	((target wasHistoryRemoved: targetHistory) and:[ baseHistory isRemoved not ])
		ifTrue: [ ^ (JETRemovedChange of: targetHistory entity) ].		

	(target wasHistoryModified: targetHistory) ifTrue: [ 
		(baseHistory notNil and:[ baseHistory isRemoved not and:[ baseHistory isModifiedRelatedTo: targetHistory ] ]) ifTrue: [ 
			^ (JETModifiedChange of: baseHistory to: targetHistory) ].
		(baseHistory isNil or:[ baseHistory notNil and:[ baseHistory isRemoved ]]) ifTrue: [
			^ (JETAddedChange of: targetHistory) ] ].
		
	(targetHistory notNil and:[ (target wasHistoryChanged: targetHistory) not and:[ targetHistory isRemoved not ] ]) ifTrue: [
		(baseHistory isNil or:[ baseHistory notNil and:[ baseHistory isRemoved ]])
			ifTrue: [ 
				^ (JETAddedChange of: targetHistory) ].
		(baseHistory notNil and:[ baseHistory isRemoved not and:[ baseHistory ~= targetHistory and:[ baseHistory isModifiedRelatedTo: targetHistory ] ] ])
			ifTrue: [ ^ (JETModifiedChange of: baseHistory to: targetHistory) ] ].
			
	((targetHistory isNil or:[ (target wasHistoryChanged: targetHistory) not and:[ targetHistory isRemoved ] ]) 
		and:[ baseHistory notNil and:[ baseHistory isRemoved not ] ])	
			ifTrue: [ ^ (JETRemovedChange of: baseHistory) ].
	^ nil! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/26/2011 00:08'!
changeWithID: id

	^ self changes detect:[ :change| change entity historyID = id ] ifNone:[ nil ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/12/2011 16:55'!
changes

	^changes! !

!JETSnapshotDelta methodsFor: 'accessing changes' stamp: 'VeronicaUquillas 11/25/2011 23:30'!
changesByEntityType
	| groupedChanges |
	
	self flag: 'should be removed'.
	groupedChanges := Dictionary new.
	groupedChanges at: #class put: (self changesByEntityType: #isClassChange).
	groupedChanges at: #method put: (self changesByEntityType: #isMethodChange).
	groupedChanges at: #package put: (self changesByEntityType: #isPackageChange).
	groupedChanges at: #instVariable put: (self changesByEntityType: #isInstanceVariableChange).
	groupedChanges at: #classVariable put: (self changesByEntityType: #isClassVariableChange).
	groupedChanges at: #poolVariable put: (self changesByEntityType: #isPoolVariableChange).
	groupedChanges at: #classInstVariable put: (self changesByEntityType: #isClassInstanceVariableChange).
	groupedChanges at: #access put: (self changesByEntityType: #isAccessChange).
	groupedChanges at: #invocation put: (self changesByEntityType: #isInvocationChange).
	groupedChanges at: #reference put: (self changesByEntityType: #isReferenceChange).
	groupedChanges at: #inheritance put: (self changesByEntityType: #isInheritanceChange).
	
	^ groupedChanges! !

!JETSnapshotDelta methodsFor: 'accessing changes' stamp: 'VeronicaUquillas 10/10/2011 15:15'!
changesByEntityType: selector

	^ changes select:[ :each | each perform: selector ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/6/2011 14:48'!
changesByIncomingNeededDelta: aRGSnapshotDelta 
	| iChanges |
	iChanges := Set new.
	(aRGSnapshotDelta changeDependencies select:[ :each| each dependOn: self  ] )
		do:[ :each| iChanges addAll: (each subDependencyDependingOn: self) ].
		
	^iChanges! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/8/2011 14:13'!
changesForDependencies
	"Return the merged changes that might include dependencies"
	^ self mergedChanges select:[ :each| each canHaveDependencies ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 20:08'!
closePredecessor: aCollection
	| positions |
	
	positions := Dictionary new.
	self allPredecessors doWithIndex: [ :each :index| 
		(aCollection includes: each)
			ifTrue: [ positions at: index put: each ] ].
	^ positions isEmpty 
		ifTrue: [ nil ]
		ifFalse:[ positions at: (positions keys min) ]! !

!JETSnapshotDelta methodsFor: 'generating deltas/dependencies' stamp: 'VeronicaUquillas 12/8/2011 16:08'!
deltaFrom: baseSnapshot to: targetSnapshot
	| baseHistory targetHistory allHistoryKeys change |	
	
	base := baseSnapshot.
	target := targetSnapshot.
	changes := OrderedCollection new.
	changeDependencies := OrderedCollection new.
	allHistoryKeys := self idsForDelta.
		
	allHistoryKeys do:[ :key|
		targetHistory := target historyWrapperAtIDEvenIfRemoved: key.
		baseHistory := base historyWrapperAtIDEvenIfRemoved: key.
		change := self changeForBaseHistory: baseHistory andTargetHistory: targetHistory.
		change ifNotNil: [ 
			change delta: self.
			changes add: change ] ]! !

!JETSnapshotDelta methodsFor: 'accessing changes' stamp: 'VeronicaUquillas 8/9/2012 18:12'!
dependentChanges

	^ changeDependencies select:[ :each| each hasDependencies ] thenCollect:[ :each| each change ] ! !

!JETSnapshotDelta methodsFor: 'generating deltas/dependencies' stamp: 'VeronicaUquillas 12/2/2011 00:44'!
dependentDeltaIncludingMergedChange: aRGHistory
	"Retrieves the receiver or the first predecessor of the receiver <another delta> in which aRGHistory historyID is present (i.e. presents any kind of change)"
	aRGHistory isNil ifTrue: [ ^ nil ].
	^ self dependentDeltaIncludingMergedChangeID: aRGHistory historyID! !

!JETSnapshotDelta methodsFor: 'generating deltas/dependencies' stamp: 'VeronicaUquillas 12/2/2011 00:05'!
dependentDeltaIncludingMergedChangeID: id
	"Retrieves the first delta in which aRGHistory historyID is present (i.e. presents any kind of change)"

	(self mergedChangeWithID: id)
		ifNotNil:[ :change|  
			^ self newSubChangeDependency: change ].
	self allIncludedPredecessors do:[ :each |
		(each mergedChangeWithID: id)
			ifNotNil:[ :change|  
				^ each newSubChangeDependency: change ] ].
	^ nil ! !

!JETSnapshotDelta methodsFor: 'generating deltas/dependencies' stamp: 'VeronicaUquillas 11/30/2011 11:58'!
diff

	self deltaFrom: base to: target ! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 7/7/2012 00:03'!
externalNeededClasses 

	^ self 
		annotationNamed: self class externalNeededClassesKey 
		 ifAbsentPut: [
			| external |
			external := Set new.
			self changeDependencies do:[ :each | 
				each hasExternalDependency ifTrue: [ external addAll: each externalDependencies classNames ] ].
			external asOrderedCollection ]! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 12/1/2011 23:29'!
hasNeededDeltas

	^ self outgoingNeededDeltas notEmpty and:[ self incomingNeededDeltas notEmpty ]! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 12/1/2011 23:21'!
hasNoNeededDeltas

	^ self outgoingNeededDeltas isEmpty and:[ self incomingNeededDeltas isEmpty ]! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 12/1/2011 23:22'!
hasOnlyIncomingNeededDeltas

	^ self outgoingNeededDeltas isEmpty and:[ self incomingNeededDeltas notEmpty ]! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 12/1/2011 23:44'!
hasOnlyOutgoingNeededDeltas

	^ self outgoingNeededDeltas notEmpty and:[ self incomingNeededDeltas isEmpty ]! !

!JETSnapshotDelta methodsFor: 'comparing' stamp: 'VeronicaUquillas 11/28/2011 16:34'!
hash

	^ self class hash bitXor: (base hash bitXor: target hash)! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 11/26/2011 19:56'!
historyTypes

	^ self annotationNamed: #historyTypes ifAbsentPut: [ Dictionary new ]! !

!JETSnapshotDelta methodsFor: 'generating deltas/dependencies' stamp: 'VeronicaUquillas 11/28/2011 23:09'!
idsForDelta
	| allHistoryKeys history |
	
	allHistoryKeys := (Set new)
		addAll: base methodIDs values asOrderedCollection;
		addAll: target methodIDs values asOrderedCollection;
		yourself.
	base classIDs values do:[ :k| 
		(history := base historyAtID: k) isExternal
			ifFalse:[ allHistoryKeys add: k; add: history metaClassID ] ].
	target classIDs values do:[ :k| 
		(history := target historyAtID: k) isExternal
			ifFalse:[ allHistoryKeys add: k; add: history metaClassID ] ].
	base packageIDs values do:[ :k| 
		(history := base historyAtID: k) isExternal
			ifFalse:[ allHistoryKeys add: k ] ].
	target packageIDs values do:[ :k| 
		(history := target historyAtID: k) isExternal
			ifFalse:[ allHistoryKeys add: k ] ].
	^ allHistoryKeys! !

!JETSnapshotDelta methodsFor: 'generating deltas/dependencies' stamp: 'VeronicaUquillas 11/28/2011 23:09'!
idsForInitialDelta
	| allHistoryKeys |
	
	allHistoryKeys := (OrderedCollection new)
		addAll: target methodIDs values asOrderedCollection.
	target classIDs values do:[ :k| | history |
		(history := target historyAtID: k) isExternal
			ifFalse:[ allHistoryKeys add: k; add: history metaClassID ] ].
	target packageIDs values do:[ :k| | history |
		(history := target historyAtID: k) isExternal
			ifFalse:[ allHistoryKeys add: k ] ].
	^ allHistoryKeys! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 11/26/2011 19:56'!
includeAccesses

	self historyTypes at: #access put: #isAccess! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 10/18/2011 11:43'!
includeAllEntities

	self includeCoreEntities.
	self includeMethodAssociations.
	self includeVariables.
	self includeInheritances! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 11/26/2011 19:56'!
includeClasses

	self historyTypes at: #class put: #isClass! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 10/18/2011 11:40'!
includeCoreEntities

	self includePackages.
	self includeClasses.
	self includeTraits.
	self includeMethods.! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 11/26/2011 19:56'!
includeInheritances

	self historyTypes at: #inheritance put: #isInheritance! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 11/26/2011 19:56'!
includeInvocations

	self historyTypes at: #invocation put: #isInvocation! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 10/18/2011 11:42'!
includeMethodAssociations

	self includeInvocations.
	self includeAccesses.
	self includeReferences! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 11/26/2011 19:56'!
includeMethods

	self historyTypes at: #method put: #isMethod! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 11/26/2011 19:56'!
includePackages

	self historyTypes at: #package put: #isPackage! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 11/26/2011 19:57'!
includeReferences

	self historyTypes at: #reference put: #isReference! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 11/26/2011 19:57'!
includeTraits

	self historyTypes at: #trait put: #isTrait! !

!JETSnapshotDelta methodsFor: 'history types for delta' stamp: 'VeronicaUquillas 11/26/2011 19:57'!
includeVariables

	self historyTypes at: #variable put: #isVariable! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 12/4/2011 03:07'!
includesOutgoingNeededDelta: aRGSnapshotDelta 

	^ self outgoingNeededDeltas includes: aRGSnapshotDelta! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 12/4/2011 02:50'!
includesOutgoingPotentialDelta: aRGSnapshotDelta 

	^ self outgoingPotentialDeltas includes: aRGSnapshotDelta! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/2/2011 01:18'!
incomingDependentDeltas

	^ (Set new) 
		addAll: self incomingNeededDeltas;
		addAll: self incomingFuzzyDeltas;
		yourself ! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/2/2011 01:17'!
incomingFuzzyDeltas

	^ incomingFuzzyDeltas! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/1/2011 22:24'!
incomingNeededDeltas

	^ incomingNeededDeltas! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/2/2011 01:17'!
incomingPotentialDeltas
	
	^ self incomingFuzzyDeltas difference: self incomingNeededDeltas ! !

!JETSnapshotDelta methodsFor: 'generating deltas/dependencies' stamp: 'VeronicaUquillas 12/19/2011 11:41'!
initialDelta: targetSnapshot
	| baseHistory targetHistory allHistoryKeys change |	
	
	target := targetSnapshot.
	base := targetSnapshot predecessors first.
	changes := OrderedCollection new.
	changeDependencies := OrderedCollection new.
	allHistoryKeys := self idsForInitialDelta.
	
	allHistoryKeys do:[ :key|
		targetHistory := target historyWrapperAtIDEvenIfRemoved: key.
		change := JETAddedChange of: targetHistory.
		change delta: self.
		changes add: change ]! !

!JETSnapshotDelta methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 12/8/2011 16:21'!
initialize 

	super initialize.
	predecessors := OrderedCollection new.
	successors := OrderedCollection new.
	incomingNeededDeltas := Set new.
	incomingFuzzyDeltas := Set new.	
	self resetChangeDependencies.! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 12/17/2011 11:12'!
isEnd

	^ self outgoingNeededDeltas notEmpty and:[ self incomingNeededDeltas isEmpty ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/1/2011 23:57'!
isExcluded

	^ self annotationNamed: #isExcluded ifAbsentPut:[ false ] ! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/1/2011 23:57'!
isExcluded: aBoolean

	^ self annotationNamed: #isExcluded put: aBoolean! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 11/26/2011 20:05'!
isHistoryApplicableForDelta: aRGHistory
	"Validates if an aRGHistory should be considered for the delta"
	
	^ (aRGHistory isMethod
		or:[	(aRGHistory isClass
				or:[ aRGHistory isTrait 
				or:[ aRGHistory isPackage ] ] ) and:[ aRGHistory isExternal not ] ] )! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 11/26/2011 20:06'!
isHistoryTypeApplicableForDelta: aRGHistory
	"Validates if a type of aRGHistory can be considered for the delta"
	
	self historyTypes values do:[ :selector |
		(aRGHistory perform: selector) ifTrue:[ ^ true ] ].
	^ false! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 12/17/2011 11:11'!
isIntermediate

	^ self outgoingNeededDeltas notEmpty and:[ self incomingNeededDeltas notEmpty ]! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 12/17/2011 11:11'!
isIsland

	^ self outgoingNeededDeltas isEmpty and:[ self incomingNeededDeltas isEmpty ]! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 1/18/2012 11:45'!
isOutgoingNeededDeltaOf: aRGSnapshotDelta 

	^ self isOutgoingNeededDeltaOf: aRGSnapshotDelta in: OrderedCollection new ! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 1/20/2012 09:33'!
isOutgoingNeededDeltaOf: aRGSnapshotDelta in: aCollection

	self flag: 'Check that no loops are still happening'.
	aRGSnapshotDelta outgoingNeededDeltas do:[ :each|
		(aCollection includes: each) ifFalse:[ 
			self = each ifTrue: [ ^true ].
			(self isOutgoingNeededDeltaOf: each in: aCollection) ifTrue: [ ^ true ].
			aCollection add: each ] ].
	^ false! !

!JETSnapshotDelta methodsFor: 'testing' stamp: 'VeronicaUquillas 12/17/2011 11:12'!
isSource

	^ self outgoingNeededDeltas isEmpty and:[ self incomingNeededDeltas notEmpty  ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 10/18/2011 13:47'!
key

	^ base name, ' - ', target name! !

!JETSnapshotDelta methodsFor: 'accessing changes' stamp: 'VeronicaUquillas 7/2/2012 19:10'!
mergedAdditions

	^ self mergedChanges select:[ :each | each isAddition ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/30/2011 14:43'!
mergedChangeWithID: id

	^ self mergedChanges detect:[ :change| change entity historyID = id ] ifNone:[ nil ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/30/2011 14:06'!
mergedChanges

	^ mergedChanges ifNil:[ changes ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/8/2011 19:21'!
mergedChanges: aCollection
	"Sets the receiver as the delta of the changes"

	mergedChanges := aCollection.
	aCollection do:[ :each| each delta: self ]! !

!JETSnapshotDelta methodsFor: 'accessing changes' stamp: 'VeronicaUquillas 7/2/2012 19:10'!
mergedModifications

	^ self mergedChanges select:[ :each | each isModification ]! !

!JETSnapshotDelta methodsFor: 'accessing changes' stamp: 'VeronicaUquillas 7/2/2012 19:11'!
mergedRemovals

	^ self mergedChanges select:[ :each | each isRemoval ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/1/2011 16:29'!
minimalName

	^ self visibleID asString, '. (', self target author, ')'! !

!JETSnapshotDelta methodsFor: 'accessing changes' stamp: 'VeronicaUquillas 10/18/2011 13:23'!
modifications

	^ self changes select:[ :each | each isModification ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/1/2011 16:24'!
name

	^ self visibleID asString, '. ', self target commitMessagesLabel! !

!JETSnapshotDelta methodsFor: 'generating deltas/dependencies' stamp: 'VeronicaUquillas 7/6/2012 23:55'!
newChangeDependency: aRGChange

	^ JETChangeDependencies new
		change: aRGChange;
		delta: self;
		yourself! !

!JETSnapshotDelta methodsFor: 'generating deltas/dependencies' stamp: 'VeronicaUquillas 7/6/2012 23:58'!
newSubChangeDependency: aRGChange

	^ aRGChange isRemoval
		ifTrue: [ nil ]
		ifFalse:[ JETChangeDependency new
					change: aRGChange;
					delta: self;
					yourself ]! !

!JETSnapshotDelta methodsFor: 'accessing changes' stamp: 'VeronicaUquillas 7/2/2012 19:03'!
nonDependentChanges

	^ self mergedChanges difference: self dependentChanges! !

!JETSnapshotDelta methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/17/2011 11:22'!
numberOfChangesWithDependencies

	^ self dependentChanges size! !

!JETSnapshotDelta methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/17/2011 11:22'!
numberOfChangesWithoutDependencies

	^ self nonDependentChanges size! !

!JETSnapshotDelta methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:42'!
numberOfClasses

	^ self target packagesButExternal inject: 0 into:[ :sum :each| sum + each classes size ] ! !

!JETSnapshotDelta methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:38'!
numberOfLinesOfCode

	^ self target packagesButExternal inject: 0 into:[ :sum :each| sum + each numberOfLinesOfCode ] ! !

!JETSnapshotDelta methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:36'!
numberOfMethods

	^ self target methods size! !

!JETSnapshotDelta methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:35'!
numberOfPackages

	^ self target packagesButExternal size! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/1/2011 21:52'!
outgoingDependentDeltas

	^ (Set new) 
		addAll: self outgoingNeededDeltas;
		addAll: self outgoingFuzzyDeltas;
		yourself ! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/2/2011 01:36'!
outgoingFuzzyDeltas

	^ outgoingFuzzyDeltas ifNil:[
		outgoingFuzzyDeltas := self changeDependencies inject: Set new into:[ :collection : dep| collection addAll: dep fuzzyDeltas; yourself ].
		outgoingFuzzyDeltas do:[ :each| each addIncomingFuzzyDelta: self ] ]! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/2/2011 00:19'!
outgoingFuzzyDeltasMap
	| map |
	
	map := Dictionary new.
	self changeDependencies do:[ :each| 
		each fuzzyDeltasMap keysAndValuesDo: [ :key :value |
			map 
				at: key 
				ifPresent:[ :sdict| sdict addAll: value ]
				ifAbsent:[ (map at: key put: Set new) addAll: value ] ] ].
	^ map! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/2/2011 01:35'!
outgoingNeededDeltas

	^ outgoingNeededDeltas ifNil:[
		outgoingNeededDeltas := self changeDependencies inject: Set new into:[ :collection : dep| collection addAll: dep neededDeltas; yourself ].
		outgoingNeededDeltas do:[ :each| each addIncomingNeededDelta: self ] ]! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/2/2011 00:19'!
outgoingNeededDeltasMap
	| map |
	
	map := Dictionary new.
	self changeDependencies do:[ :each| 
		each neededDeltasMap keysAndValuesDo: [ :key :value |
			map 
				at: key 
				ifPresent:[ :sdict| sdict addAll: value ]
				ifAbsent:[ (map at: key put: Set new) addAll: value ] ] ].
	^ map! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/1/2011 21:45'!
outgoingPotentialDeltas
	
	^ self outgoingFuzzyDeltas difference: self outgoingNeededDeltas ! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/1/2011 21:46'!
outgoingPotentialDeltasMap
	| map |
	map := Dictionary new.
	map addAll: self outgoingFuzzyDeltasMap.
	self outgoingNeededDeltas do:[ :each|
		(map includesKey: each) ifTrue:[ map removeKey: each ] ].
	^ map! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/8/2011 13:46'!
predecessors

	^ predecessors! !

!JETSnapshotDelta methodsFor: 'printing' stamp: 'VeronicaUquillas 12/1/2011 22:17'!
printOn: aStream

	aStream nextPutAll: self minimalName! !

!JETSnapshotDelta methodsFor: 'generating deltas/dependencies' stamp: 'VeronicaUquillas 12/2/2011 02:04'!
recalculateOutgoingDeltasOf: aRGSnapshotDelta 
	"When aRGSnapshotDelta isExcluded the receiver needs to find new dependencies if exists"
	| invalidChangeDeps |
	
	invalidChangeDeps := self changeDependencies select:[ :each| each dependOn: aRGSnapshotDelta ].
	invalidChangeDeps do:[ :each|
		each resetCollections.
		each calculateDependencies ].
	self resetOutgoingNeededDeltas.
	self resetOutgoingFuzzyDeltas.
! !

!JETSnapshotDelta methodsFor: 'accessing changes' stamp: 'VeronicaUquillas 10/18/2011 13:23'!
removals

	^ self changes select:[ :each | each isRemoval ]! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 12/2/2011 03:22'!
removeChangeDependenciesOf: aRGSnapshotDelta

	(changeDependencies select:[ :each| each dependOn: aRGSnapshotDelta ])
		do:[ :each| each removeDependenciesOf: aRGSnapshotDelta ]! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 12/2/2011 00:24'!
removeChangeDependency: aRGChangeDependency

	changeDependencies remove: aRGChangeDependency! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 8/9/2012 18:12'!
removeEmptyChangeDependencies
	| toRemove |
	
	toRemove := changeDependencies select:[ :each| each hasDependencies not and:[ each hasMissingDependencies not ] ].
	changeDependencies removeAll: toRemove! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 12/2/2011 01:53'!
removeIncomingFuzzyDelta: aRGSnapshotDelta 

	incomingFuzzyDeltas remove: aRGSnapshotDelta ifAbsent:[]! !

!JETSnapshotDelta methodsFor: 'adding/removing' stamp: 'VeronicaUquillas 12/2/2011 02:05'!
removeIncomingNeededDelta: aRGSnapshotDelta 

	incomingNeededDeltas remove: aRGSnapshotDelta ifAbsent:[]! !

!JETSnapshotDelta methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 1/18/2012 11:05'!
resetChangeDependencies 

	changeDependencies := OrderedCollection new.
	outgoingFuzzyDeltas := nil.
	outgoingNeededDeltas := nil.
	self resetTraversedDeltas
			! !

!JETSnapshotDelta methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 1/18/2012 11:05'!
resetIncomingDeltas

	incomingNeededDeltas := Set new.
	incomingFuzzyDeltas := Set new.
	self resetTraversedDeltas.! !

!JETSnapshotDelta methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 1/18/2012 11:05'!
resetOutgoingFuzzyDeltas

	outgoingFuzzyDeltas notNil ifTrue: [ 
		outgoingFuzzyDeltas do:[ :each| each removeIncomingFuzzyDelta: self ].
		outgoingFuzzyDeltas := nil.
		self resetTraversedDeltas ]! !

!JETSnapshotDelta methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 1/18/2012 11:01'!
resetOutgoingNeededDeltas

	outgoingNeededDeltas notNil ifTrue: [ 
		outgoingNeededDeltas do:[ :each| each removeIncomingNeededDelta: self ].
		outgoingNeededDeltas := nil.
		self resetTraversedDeltas ]! !

!JETSnapshotDelta methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 1/18/2012 11:01'!
resetTraversedDeltas

	traversedOutgoingPotentialDeltas := nil.
	traversedOutgoingNeededDeltas := nil.
	traversedIncomingNeededDeltas := nil.
	traversedIncomingPotentialDeltas := nil! !

!JETSnapshotDelta methodsFor: 'sorting' stamp: 'VeronicaUquillas 11/15/2011 17:23'!
sortByTimestampDesc

	^ [ :e1 :e2| e1 target timeStamp > e2 target timeStamp ]! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/8/2011 16:21'!
successors 

	^ successors ! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 10/18/2011 16:10'!
target

	^ target! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/29/2011 21:56'!
target: aRGSnapshotRepository

	target := aRGSnapshotRepository! !

!JETSnapshotDelta methodsFor: 'private' stamp: 'VeronicaUquillas 1/18/2012 11:06'!
traversedDeltasMap: aDictionary selector: aSymbol
	
	 (self perform: aSymbol) do:[ :each|
		(aDictionary includesKey: each) ifFalse:[
			(each outgoingNeededDeltas) notEmpty ifTrue: [
				aDictionary at: each put: (each outgoingNeededDeltas) ].
			each traversedDeltasMap: aDictionary selector: #outgoingNeededDeltas
			] ].
	^ aDictionary
! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 1/17/2012 17:49'!
traversedIncomingNeededDeltas

	^ traversedIncomingNeededDeltas ifNil:[
		|  myNeededDeltas |
	
		myNeededDeltas := OrderedCollection new.
		self incomingNeededDeltas do:[ :each|
			(each traversedOutgoingNeededDeltas includes: self)
				ifTrue: [ myNeededDeltas add: each ] ].
		traversedIncomingNeededDeltas := myNeededDeltas ]! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 1/17/2012 17:49'!
traversedIncomingPotentialDeltas

	^ traversedIncomingPotentialDeltas ifNil:[
		|  myNeededDeltas |
	
		myNeededDeltas := OrderedCollection new.
		self incomingPotentialDeltas do:[ :each|
			(each traversedOutgoingPotentialDeltas includes: self)
				ifTrue: [ myNeededDeltas add: each ] ].
		traversedIncomingPotentialDeltas := myNeededDeltas ]! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 1/17/2012 17:48'!
traversedOutgoingNeededDeltas

	^ traversedOutgoingNeededDeltas ifNil:[
		| neededDeltasMap removableDeltas myNeededDeltas |
	
		neededDeltasMap := self traversedOutgoingNeededDeltasMap.
		removableDeltas := OrderedCollection new.
		myNeededDeltas := OrderedCollection withAll: self outgoingNeededDeltas.
		myNeededDeltas do:[ :each|
			neededDeltasMap keysAndValuesDo: [ :key :value|
				(value includes: each)
					ifTrue: [ removableDeltas add: each ] ] ].
		
		traversedOutgoingNeededDeltas := myNeededDeltas difference: removableDeltas ]! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/1/2011 21:35'!
traversedOutgoingNeededDeltasMap

	^ self traversedOutgoingNeededDeltasMap: Dictionary new! !

!JETSnapshotDelta methodsFor: 'private' stamp: 'VeronicaUquillas 12/1/2011 22:40'!
traversedOutgoingNeededDeltasMap: aDictionary
	
	^ self traversedDeltasMap: aDictionary selector: #outgoingNeededDeltas! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 1/17/2012 17:48'!
traversedOutgoingPotentialDeltas

	^ traversedOutgoingPotentialDeltas ifNil:[
		| potentialDeltasMap removableDeltas myPotentialDeltas |
		
		potentialDeltasMap := self traversedOutgoingPotentialDeltasMap.
		removableDeltas := OrderedCollection new.
		myPotentialDeltas := OrderedCollection withAll: self outgoingPotentialDeltas.
		myPotentialDeltas do:[ :each|
			potentialDeltasMap keysAndValuesDo: [ :key :value|
				(value includes: each)
					ifTrue: [ removableDeltas add: each ] ] ].
		
		traversedOutgoingPotentialDeltas := myPotentialDeltas difference: removableDeltas ]
	
	! !

!JETSnapshotDelta methodsFor: 'dependencies' stamp: 'VeronicaUquillas 12/1/2011 21:35'!
traversedOutgoingPotentialDeltasMap

	^ self traversedOutgoingPotentialDeltasMap: Dictionary new! !

!JETSnapshotDelta methodsFor: 'private' stamp: 'VeronicaUquillas 12/1/2011 22:40'!
traversedOutgoingPotentialDeltasMap: aDictionary
	
	^ self traversedDeltasMap: aDictionary selector: #outgoingPotentialDeltas! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/1/2011 18:01'!
visibleID

	^ self annotationNamed: #visibleID ! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/1/2011 18:01'!
visibleID: aNumber

	self annotationNamed: #visibleID put: aNumber ! !

!JETSnapshotDelta methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/26/2011 21:26'!
withAllPredecessors
	
	^ (OrderedCollection with: self)
		addAll: self allPredecessors;
		yourself ! !

Object subclass: #JETLOCParser
	instanceVariableNames: 'loc tmpIns tmpRem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETLOCParser classSide methodsFor: 'parsing' stamp: 'VeronicaUquillas 5/31/2010 14:22'!
nroModifiedLOCs: patchSequence

	^self new
		nroModifiedLOCs: patchSequence ! !

!JETLOCParser classSide methodsFor: 'parsing' stamp: 'VeronicaUquillas 5/17/2010 16:32'!
nroModifiedLOCsFrom: oldText to: newText

	^self new
		nroModifiedLOCsFrom: oldText to: newText! !

!JETLOCParser classSide methodsFor: 'parsing' stamp: 'VeronicaUquillas 5/17/2010 17:26'!
patchSequenceFrom: oldText to: newText

	^(TextDiffBuilder 
			from: oldText   
			to: newText) buildPatchSequence.! !

!JETLOCParser methodsFor: 'parsing' stamp: 'VeronicaUquillas 5/17/2010 17:07'!
conditionBothGreaterThanZero
	(tmpIns > 0 and: [ tmpRem > 0 ])
		ifFalse: [ ^ self ].
	tmpIns > tmpRem
		ifTrue: [ loc := loc + tmpIns ].
	tmpRem >= tmpIns
		ifTrue: [ loc := loc + tmpRem ].
	tmpIns := 0.
	tmpRem := 0! !

!JETLOCParser methodsFor: 'parsing' stamp: 'VeronicaUquillas 5/17/2010 17:07'!
conditionInsEqualZero
	tmpIns = 0
		ifFalse: [ ^ self ].
	loc := loc + tmpRem.
	tmpRem := 0! !

!JETLOCParser methodsFor: 'parsing' stamp: 'VeronicaUquillas 5/17/2010 17:07'!
conditionInsGreaterThanZeroAndRemEqualZero
	(tmpIns > 0 and: [ tmpRem = 0 ])
		ifFalse: [ ^ self ].
	loc := loc + tmpIns.
	tmpIns := 0! !

!JETLOCParser methodsFor: 'parsing' stamp: 'VeronicaUquillas 5/17/2010 17:07'!
conditionRemGreaterThanZeroAndInsEqualZero
	(tmpRem > 0 and: [ tmpIns = 0 ])
		ifFalse: [ ^ self ].
	loc := loc + tmpRem.
	tmpRem := 0! !

!JETLOCParser methodsFor: 'parsing' stamp: 'VeronicaUquillas 4/28/2010 16:01'!
increaseIns

	tmpIns:= tmpIns + 1! !

!JETLOCParser methodsFor: 'parsing' stamp: 'VeronicaUquillas 4/28/2010 16:01'!
increaseRem

	tmpRem:= tmpRem + 1! !

!JETLOCParser methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 4/28/2010 15:47'!
initialize

	loc:= 0.
	tmpIns:= 0.
	tmpRem:= 0! !

!JETLOCParser methodsFor: 'parsing' stamp: 'VeronicaUquillas 5/31/2010 14:21'!
nroModifiedLOCs: patchSequence
	| key prevKey |

	prevKey:= patchSequence first key.
	
	patchSequence do:[ :keyValue| 
		key:= keyValue key.	
		key == #insert
		ifTrue:[ prevKey == #remove
			    ifTrue:[
				self conditionBothGreaterThanZero.
				self conditionInsEqualZero ].
			    self increaseIns ].
		
		key == #remove
		ifTrue:[ self increaseRem ].
		
		key == #match
		ifTrue:[
			self conditionInsGreaterThanZeroAndRemEqualZero.
			self conditionRemGreaterThanZeroAndInsEqualZero.
			self conditionBothGreaterThanZero. ].
		
		key == prevKey 
		ifFalse: [ prevKey:= key ] ].
	
	self conditionInsGreaterThanZeroAndRemEqualZero.
	self conditionRemGreaterThanZeroAndInsEqualZero.
	self conditionBothGreaterThanZero. 
				
	^loc! !

!JETLOCParser methodsFor: 'parsing' stamp: 'VeronicaUquillas 5/31/2010 14:22'!
nroModifiedLOCsFrom: oldText to: newText
	| patchSeq |

	patchSeq:= self class patchSequenceFrom: oldText to: newText.	
	^self nroModifiedLOCs: patchSeq! !

!JETLOCParser methodsFor: 'parsing' stamp: 'VeronicaUquillas 5/18/2010 09:41'!
nroUnmodifiedLOCsFrom: oldText to: newText
	"clank lines are not taken into account also the line of the method declaration"
	| patch matchLines |

	patch:= self class patchSequenceFrom: oldText to: newText.	
	matchLines:= patch select:[ :keyValue| keyValue key = #match ].
	matchLines removeAllSuchThat:[ :line| line value withBlanksTrimmed isEmpty ].
	
	^matchLines size - 1


! !

Object subclass: #JETSnapshotDeltaStream
	instanceVariableNames: 'deltas dependenciesPerDelta groupOfDependencies'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Jet-Model'!

!JETSnapshotDeltaStream classSide methodsFor: 'operations' stamp: 'VeronicaUquillas 10/10/2012 12:59'!
current
	^ Current! !

!JETSnapshotDeltaStream classSide methodsFor: 'running' stamp: 'VeronicaUquillas 11/26/2011 00:21'!
generateDeltaHistoryOf: aRGRepositoryImport

	^ self new
		generateDeltaHistoryOf: aRGRepositoryImport! !

!JETSnapshotDeltaStream classSide methodsFor: 'running' stamp: 'VeronicaUquillas 10/10/2012 13:14'!
generateStreamOfChanges
	
	Current ifNil:[ Current := (self generateDeltaHistoryOf: RGHistoryRepository current) calculateDependencies ].! !

!JETSnapshotDeltaStream classSide methodsFor: 'operations' stamp: 'VeronicaUquillas 10/10/2012 13:12'!
reset

	Current := nil! !

!JETSnapshotDeltaStream methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/8/2011 17:04'!
addDelta: aRGSnapshotDelta

	deltas add: aRGSnapshotDelta! !

!JETSnapshotDeltaStream methodsFor: 'calculating dependencies' stamp: 'VeronicaUquillas 12/9/2011 11:43'!
calculateChangedDependencies

	groupOfDependencies := 'dependencies of changed code'.
	deltas 
		do:[ :each| self changedDependenciesOfDelta: each ]
		displayingProgress: 'Calculating Dependencies...'.! !

!JETSnapshotDeltaStream methodsFor: 'calculating dependencies' stamp: 'VeronicaUquillas 12/9/2011 11:43'!
calculateDependencies

	groupOfDependencies := 'all dependencies'.
	deltas 
		do:[ :each| self dependenciesOfDelta: each ]
		displayingProgress: 'Calculating Dependencies...'.! !

!JETSnapshotDeltaStream methodsFor: 'calculating dependencies' stamp: 'VeronicaUquillas 12/9/2011 11:21'!
changedDependenciesOfDelta: aRGSnapshotDelta
	| changeDependency |
	
	(dependenciesPerDelta includesKey: aRGSnapshotDelta key) ifFalse:[
		aRGSnapshotDelta resetChangeDependencies.
		aRGSnapshotDelta isExcluded: false.
		aRGSnapshotDelta changesForDependencies do:[ :change|
			changeDependency := aRGSnapshotDelta newChangeDependency: change.
			changeDependency calculateChangedDependencies.
			aRGSnapshotDelta addChangeDependency: changeDependency ].
		dependenciesPerDelta 
			at: aRGSnapshotDelta key 
			put: aRGSnapshotDelta changeDependencies ].! !

!JETSnapshotDeltaStream methodsFor: 'accessing' stamp: 'VeronicaUquillas 10/18/2011 10:27'!
deltas

	^ deltas! !

!JETSnapshotDeltaStream methodsFor: 'calculating dependencies' stamp: 'VeronicaUquillas 7/2/2012 17:37'!
dependenciesOfDelta: aRGSnapshotDelta
	| changeDependency |
	
	(dependenciesPerDelta includesKey: aRGSnapshotDelta key) ifFalse:[
		aRGSnapshotDelta resetChangeDependencies.
		aRGSnapshotDelta isExcluded: false.
		aRGSnapshotDelta changesForDependencies do:[ :change|
			changeDependency := aRGSnapshotDelta newChangeDependency: change.
			changeDependency calculateDependencies.
			aRGSnapshotDelta addChangeDependency: changeDependency ].
		aRGSnapshotDelta removeEmptyChangeDependencies.
		dependenciesPerDelta 
			at: aRGSnapshotDelta key 
			put: aRGSnapshotDelta changeDependencies ].! !

!JETSnapshotDeltaStream methodsFor: 'operations' stamp: 'VeronicaUquillas 12/2/2011 03:25'!
excludeDeltaRecalculatingDependencies: aRGSnapshotDelta 

	aRGSnapshotDelta isExcluded: true.
	aRGSnapshotDelta incomingDependentDeltas do:[ :each|
		each recalculateOutgoingDeltasOf: aRGSnapshotDelta ].
	aRGSnapshotDelta resetIncomingDeltas.
	aRGSnapshotDelta outgoingNeededDeltas do:[ :each|
		each removeIncomingNeededDelta: aRGSnapshotDelta.
		each removeIncomingFuzzyDelta: aRGSnapshotDelta ].
	aRGSnapshotDelta outgoingPotentialDeltas do:[ :each|
		each removeIncomingFuzzyDelta: aRGSnapshotDelta ].
	! !

!JETSnapshotDeltaStream methodsFor: 'operations' stamp: 'VeronicaUquillas 7/2/2012 17:31'!
excludeDeltaRemovingDependencies: aRGSnapshotDelta 

	aRGSnapshotDelta isExcluded: true.
	aRGSnapshotDelta incomingDependentDeltas do:[ :each|
		each removeChangeDependenciesOf: aRGSnapshotDelta.
		each resetOutgoingNeededDeltas.
		each resetOutgoingFuzzyDeltas ].
	aRGSnapshotDelta resetIncomingDeltas.
	aRGSnapshotDelta outgoingNeededDeltas do:[ :each|
		each removeIncomingNeededDelta: aRGSnapshotDelta.
		each removeIncomingFuzzyDelta: aRGSnapshotDelta ].
	aRGSnapshotDelta outgoingPotentialDeltas do:[ :each|
		each removeIncomingFuzzyDelta: aRGSnapshotDelta ].
	aRGSnapshotDelta removeEmptyChangeDependencies
	! !

!JETSnapshotDeltaStream methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/30/2011 13:06'!
findDelta: aSnapshotDelta

	^ deltas detect:[ :each|  each base = aSnapshotDelta base and:[ each target = aSnapshotDelta target ] ] ifNone:[ nil ]! !

!JETSnapshotDeltaStream methodsFor: 'generating deltas' stamp: 'VeronicaUquillas 12/9/2011 11:22'!
generateDeltaHistoryOf: aRGRepositoryImport
	| roots merged |
	
	roots := aRGRepositoryImport snapshots select:[ :each| each hasPredecessors not ].
	roots do:[ :each| 
		self addDelta: (self newDelta initialDelta: each).
		self generateDeltaHistoryOfSuccessor: each ]
		displayingProgress: 'Diffing Snapshots...'.
	roots size to: deltas size do:[ :index|
		self lookForPredecessorsOfDelta: (deltas at: index) ].
	
	merged := aRGRepositoryImport snapshots select: [ :each| each wasMerged ].	
	merged do:[ :each| self processMergedSnapshot: each of:  aRGRepositoryImport snapshots ].
	
	deltas := self sortDeltas: deltas.
	deltas reversed withIndexDo: [ :each :index| each visibleID: index ].! !

!JETSnapshotDeltaStream methodsFor: 'generating deltas' stamp: 'VeronicaUquillas 11/30/2011 11:58'!
generateDeltaHistoryOfSuccessor: aRGSnapshot

	aRGSnapshot successors do:[ :succ| | delta |
		delta := self newDeltaFrom: aRGSnapshot to: succ.
		(self includeDelta: delta) ifFalse:[
			delta diff.
			self addDelta: delta.
			self generateDeltaHistoryOfSuccessor: succ ] ].! !

!JETSnapshotDeltaStream methodsFor: 'accessing' stamp: 'VeronicaUquillas 12/9/2011 11:45'!
groupOfDependencies

	^ groupOfDependencies! !

!JETSnapshotDeltaStream methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/30/2011 13:06'!
includeDelta: aSnapshotDelta

	^ (self findDelta: aSnapshotDelta) notNil! !

!JETSnapshotDeltaStream methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 8/17/2012 09:51'!
initialize 

	super initialize.
	deltas := OrderedCollection new.
	dependenciesPerDelta := Dictionary new.
	self flag: 'temporarily'.
	sortedSnapshots := RGHistoryRepository current importer snapshotGraph sortedSnapshots.! !

!JETSnapshotDeltaStream methodsFor: 'generating deltas' stamp: 'VeronicaUquillas 12/8/2011 16:22'!
lookForPredecessorsOfDelta: aRGSnapshotDelta
	| predecessor |
		
	aRGSnapshotDelta base predecessors do:[ :predBase|
		aRGSnapshotDelta target predecessors do:[ :predTarget|
			predecessor := deltas detect:[ :each| each base = predBase and:[ each target = predTarget ]] ifNone:[ nil ].
			predecessor notNil ifTrue: [ 
				aRGSnapshotDelta addPredecessor: predecessor.
				predecessor addSuccessor: aRGSnapshotDelta ] ] ]! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:52'!
metricGroups

	^ #( 'Entities' 'Deltas' 'Changes' )! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:52'!
metrics
	| list |
	
	list := Dictionary new.
	list 
		at: 'Sources' put: #numberOfSources;
		at: 'Intermediates' put: #numberOfIntermediates;
	 	at: 'Ends' put: #numberOfEnds;
		at: 'Islands' put: #numberOfIslands;
		at: 'Changes' put: #numberOfChanges;
		at: 'With dependencies' put: #numberOfChangesWithDependencies;
		at: 'Without dependencies' put: #numberOfChangesWithoutDependencies;
		at: 'Deltas' put: #numberOfDeltas;
		at: 'Packages' put: #numberOfPackages;
		at: 'Classes' put: #numberOfClasses;
		at: 'Methods' put: #numberOfMethods;
		at: 'LOC' put:  #numberOfLinesOfCode;
		yourself.
	^ list! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:48'!
metricsOfGroup: aString

	aString = 'Entities'
		ifTrue: [ ^ #('Packages' 'Classes' 'Methods' 'LOC') ].
	aString = 'Changes'
		ifTrue: [ ^ #('With dependencies' 'Without dependencies') ].
	aString = 'Deltas'
		ifTrue: [ ^ #('Sources' 'Intermediates' 'Ends' 'Islands') ].
	^ #()! !

!JETSnapshotDeltaStream methodsFor: 'object creation' stamp: 'VeronicaUquillas 12/19/2011 14:05'!
newDelta

	^ JETSnapshotDelta new! !

!JETSnapshotDeltaStream methodsFor: 'object creation' stamp: 'VeronicaUquillas 12/19/2011 14:05'!
newDeltaFrom: theBase to: theTarget

	^ JETSnapshotDelta from: theBase to: theTarget! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/6/2012 09:02'!
numberOfChanges

	^ self numberOfChangesWithDependencies + self numberOfChangesWithoutDependencies ! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/17/2011 13:23'!
numberOfChangesWithDependencies 

	^ (self deltas inject: 0 into: [ :sum :each| sum + each numberOfChangesWithDependencies  ])

	! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/17/2011 13:23'!
numberOfChangesWithoutDependencies 

	^ (self deltas inject: 0 into: [ :sum :each| sum + each numberOfChangesWithoutDependencies  ])

	! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:36'!
numberOfClasses

	^ self deltas first numberOfClasses! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:30'!
numberOfDeltas

	^ self deltas size! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/17/2011 11:15'!
numberOfEnds

	^ (self deltas select:[ :each| each isEnd ]) size! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/17/2011 11:15'!
numberOfIntermediates

	^ (self deltas select:[ :each| each isIntermediate ]) size! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/17/2011 11:15'!
numberOfIslands

	^ (self deltas select:[ :each| each isIsland ]) size! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:36'!
numberOfLinesOfCode

	^ self deltas first numberOfLinesOfCode! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:36'!
numberOfMethods

	^ self deltas first numberOfMethods! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 1/5/2012 14:35'!
numberOfPackages

	^ self deltas first numberOfPackages! !

!JETSnapshotDeltaStream methodsFor: 'metrics' stamp: 'VeronicaUquillas 12/17/2011 11:14'!
numberOfSources

	^ (self deltas select:[ :each| each isSource ]) size! !

!JETSnapshotDeltaStream methodsFor: 'generating deltas' stamp: 'VeronicaUquillas 8/17/2012 10:33'!
processMergedSnapshot: aRGSnapshot of: snapshots
	| pairs commonParentPredecessor closestPredecessor otherPredecessors delta deltaCS deltaCP deltaPS deltaClosest closestAllChanges |

	commonParentPredecessor := aRGSnapshot commonParentPredecessor.
	commonParentPredecessor ifNil:[ ^ self ].
	
	pairs := (aRGSnapshot predecessors collect:[ :each| (snapshots indexOf: each) -> each ]) asDictionary.
	closestPredecessor := pairs at: pairs keys max.
	"deltaClosest := self findDelta: (self newDeltaFrom: closestPredecessor to: aRGSnapshot).
	closestAllChanges := deltaClosest changes."
	otherPredecessors := aRGSnapshot predecessors difference: { closestPredecessor}.
	deltaCS := self newDeltaFrom: commonParentPredecessor to: aRGSnapshot.
	deltaCS diff.
	
	otherPredecessors do:[ :pred|
		delta := self newDeltaFrom: commonParentPredecessor to: pred.
		deltaCP := delta diff.
		delta := self newDeltaFrom: pred to: aRGSnapshot.
		(deltaPS := self findDelta: delta) isNil
			ifTrue: [ delta diff.
					deltaPS := delta ].		
		deltaPS mergedChanges: ((deltaPS changes difference: deltaCS changes) union: deltaCP changes) asOrderedCollection.
		"closestAllChanges := closestAllChanges difference: deltaPS mergedChanges" ].
	"deltaClosest mergedChanges: closestAllChanges."! !

!JETSnapshotDeltaStream methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 11/4/2011 10:59'!
resetDependencies

	dependenciesPerDelta := Dictionary new! !

!JETSnapshotDeltaStream methodsFor: 'sorting' stamp: 'VeronicaUquillas 12/1/2011 22:18'!
sortDeltas: aCollection
	
	^ aCollection asOrderedCollection sort: self sortDeltasBlock ! !

!JETSnapshotDeltaStream methodsFor: 'sorting' stamp: 'VeronicaUquillas 8/17/2012 13:35'!
sortDeltasBlock
	
	self flag: 'verify when timeStamp should not affect the order'.
	^ [ :e1 :e2| 
		(e1 target timeStamp = e2 target timeStamp)
			ifTrue: [ (e2 base isNilHistory or:[ e1 base isNilHistory ])
						ifTrue: [ e1 target timeStamp > e2 target timeStamp ]
						ifFalse:[ 
							(sortedSnapshots indexOf: (sortedSnapshots select:[ :s| s timestamp printString = e1 base timeStamp printString ]) first) > 							(sortedSnapshots indexOf: (sortedSnapshots select:[ :s| s timestamp printString = e2 base timeStamp printString ]) first)
							"e1 base timeStamp > e2 base timeStamp" ] ] 
			ifFalse:[ e1 target timeStamp > e2 target timeStamp ] ]! !
